!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
! The massive rotating straight segment
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
   DOUBLE PRECISION, INTENT(OUT) :: F(NDIM), DFDU(NDIM,*), DFDP(NDIM,*)

   DOUBLE PRECISION x,y,z,xp,yp,zp,lambda,mu,T,r1,r2,p,s

   x  = U(1)
   y  = U(2)
   z  = U(3)
   xp = U(4)
   yp = U(5)
   zp = U(6)

   lambda = PAR(1)
   mu = PAR(2)

   r1 = SQRT((x-1)**2 + y**2 + z**2)
   r2 = SQRT((x+1)**2 + y**2 + z**2)

   p = (r1+r2)*r1*r2
   s = 4.d0/(r1+r2)**2

   F(1)= xp
   F(2)= yp
   F(3)= zp
   F(4)= 2*yp + x * ( 1 - 2*mu/p )        + lambda*xp
   F(5)=-2*xp + y * (1 - 2*mu/(p*(1-s)) ) + lambda*yp
   F(6)=      - z*2*mu/(p*(1-s))          + lambda*zp

   T=PAR(14)
   F = T*F

 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 
 SUBROUTINE STPNT
 END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!---------- ----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
   DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
   DOUBLE PRECISION, INTENT(OUT) :: FB(NBC), DBC(NBC,*)

   DOUBLE PRECISION eps,x,y,z,xp,yp,zp,mu,dE,dM,U,E,J
   INTEGER m

   eps=PAR(13)
!  PAR(25:30) are USTART and PAR(31:36) are VSTART
   m=MIN(NBC,NDIM)
   FB(1:m) =  U0(1:m) - ( PAR(25:25+m-1) + eps*PAR(31:31+m-1) )

! PAR(21:23) contain the x,y,z-coordinates of the end point of 
! manifold orbits
   FB(NDIM+1:NDIM+3) = U1(1:3) - PAR(21:23)

 END SUBROUTINE BCND
!---------------------------------------------------------------------- 
 SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!---------- ----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
   DOUBLE PRECISION, INTENT(IN) :: PAR(*)
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
   DOUBLE PRECISION, INTENT(OUT) :: FI(NINT), DINT(NINT,*)

   DOUBLE PRECISION FF(NDIM),DFDU(1),DFDP(1)

   CALL FUNC(NDIM,U,ICP,PAR,0,FF,DFDU,DFDP)

! The length of the orbit in the manifold is put in PAR(12):
   FI(1)=SQRT(FF(1)**2 + FF(2)**2 + FF(3)**2 ) - PAR(12)

 END SUBROUTINE ICND
!---------------------------------------------------------------------- 
 SUBROUTINE FOPT 
 END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
 SUBROUTINE PVLS
 END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
